"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryRoles = exports.getRoles = exports.unassignRole = exports.assignRole = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixMembersV1Role = __importStar(require("./members-v1-role-authorization.http.js"));
/** @public
 * @documentationMaturity preview
 * @requiredField memberId
 * @requiredField roleKey
 * @permissionId MEMBERS.MEMBER_ROLES_MANAGE
 * @applicableIdentity MEMBER
 * @fqn com.wixpress.members.memberroles.MemberRoles.AssignRole
 */
async function assignRole(memberId, roleKey) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        memberId: memberId,
        roleKey: roleKey,
    });
    const reqOpts = ambassadorWixMembersV1Role.assignRole(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { memberId: '$[0]', roleKey: '$[1]' },
            singleArgumentUnchanged: false,
        }, ['memberId', 'roleKey']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.assignRole = assignRole;
/** @public
 * @documentationMaturity preview
 * @requiredField memberId
 * @requiredField roleKey
 * @permissionId MEMBERS.MEMBER_ROLES_MANAGE
 * @applicableIdentity MEMBER
 * @fqn com.wixpress.members.memberroles.MemberRoles.UnassignRole
 */
async function unassignRole(memberId, roleKey) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        memberId: memberId,
        roleKey: roleKey,
    });
    const reqOpts = ambassadorWixMembersV1Role.unassignRole(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { memberId: '$[0]', roleKey: '$[1]' },
            singleArgumentUnchanged: false,
        }, ['memberId', 'roleKey']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.unassignRole = unassignRole;
/** @public
 * @documentationMaturity preview
 * @requiredField memberId
 * @permissionId MEMBERS.ROLES_READ
 * @applicableIdentity VISITOR
 * @fqn com.wixpress.members.memberroles.MemberRoles.GetRoles
 */
async function getRoles(memberId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({ memberId: memberId });
    const reqOpts = ambassadorWixMembersV1Role.getRoles(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { memberId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['memberId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.getRoles = getRoles;
/** @public
 * @documentationMaturity preview
 * @permissionId MEMBERS.ROLES_READ
 * @applicableIdentity VISITOR
 * @fqn com.wixpress.members.memberroles.MemberRoles.QueryRoles
 */
async function queryRoles(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        query: options?.query,
    });
    const reqOpts = ambassadorWixMembersV1Role.queryRoles(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { query: '$[0].query' },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.queryRoles = queryRoles;
//# sourceMappingURL=members-v1-role-authorization.universal.js.map