import { toURLSearchParams } from '@wix/sdk-runtime/rest-modules';
import { resolveUrl } from '@wix/sdk-runtime/rest-modules';
function resolveComWixpressMembersMemberrolesMemberRolesUrl(opts) {
    const domainToMappings = {
        'api._api_base_domain_': [
            {
                srcPath: '/members/v1/roles',
                destPath: '',
            },
        ],
        _: [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'www._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'members.wixapps.net': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'www.wixapis.com': [
            {
                srcPath: '/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'editor._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'blocks._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'create.editorx': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        '*.dev.wix-code.com': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'manage._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
    };
    return resolveUrl(Object.assign(opts, { domainToMappings }));
}
const PACKAGE_NAME = '@wix/auto_sdk_members_authorization';
export function assignRole(payload) {
    function __assignRole({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'POST',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.AssignRole',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            data: payload,
        };
        return metadata;
    }
    return __assignRole;
}
export function unassignRole(payload) {
    function __unassignRole({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'DELETE',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.UnassignRole',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            params: toURLSearchParams(payload),
        };
        return metadata;
    }
    return __unassignRole;
}
export function getRoles(payload) {
    function __getRoles({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'GET',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.GetRoles',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            params: toURLSearchParams(payload),
        };
        return metadata;
    }
    return __getRoles;
}
export function queryRoles(payload) {
    function __queryRoles({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'POST',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.QueryRoles',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/query',
                data: payload,
                host,
            }),
            data: payload,
        };
        return metadata;
    }
    return __queryRoles;
}
//# sourceMappingURL=members-v1-role-authorization.http.js.map