"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryRoles = exports.getRoles = exports.unassignRole = exports.assignRole = void 0;
const rest_modules_1 = require("@wix/sdk-runtime/rest-modules");
const rest_modules_2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressMembersMemberrolesMemberRolesUrl(opts) {
    const domainToMappings = {
        'api._api_base_domain_': [
            {
                srcPath: '/members/v1/roles',
                destPath: '',
            },
        ],
        _: [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'www._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'members.wixapps.net': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'www.wixapis.com': [
            {
                srcPath: '/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'editor._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'blocks._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'create.editorx': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        '*.dev.wix-code.com': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
        'manage._base_domain_': [
            {
                srcPath: '/_api/members/v1/roles',
                destPath: '/v1/roles',
            },
        ],
    };
    return (0, rest_modules_2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
const PACKAGE_NAME = '@wix/auto_sdk_members_authorization';
function assignRole(payload) {
    function __assignRole({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'POST',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.AssignRole',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            data: payload,
        };
        return metadata;
    }
    return __assignRole;
}
exports.assignRole = assignRole;
function unassignRole(payload) {
    function __unassignRole({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'DELETE',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.UnassignRole',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            params: (0, rest_modules_1.toURLSearchParams)(payload),
        };
        return metadata;
    }
    return __unassignRole;
}
exports.unassignRole = unassignRole;
function getRoles(payload) {
    function __getRoles({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'GET',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.GetRoles',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/{memberId}',
                data: payload,
                host,
            }),
            params: (0, rest_modules_1.toURLSearchParams)(payload),
        };
        return metadata;
    }
    return __getRoles;
}
exports.getRoles = getRoles;
function queryRoles(payload) {
    function __queryRoles({ host }) {
        const metadata = {
            entityFqdn: 'wix.members.v1.role',
            method: 'POST',
            methodFqn: 'com.wixpress.members.memberroles.MemberRoles.QueryRoles',
            packageName: PACKAGE_NAME,
            url: resolveComWixpressMembersMemberrolesMemberRolesUrl({
                protoPath: '/v1/roles/members/query',
                data: payload,
                host,
            }),
            data: payload,
        };
        return metadata;
    }
    return __queryRoles;
}
exports.queryRoles = queryRoles;
//# sourceMappingURL=members-v1-role-authorization.http.js.map