import { HttpClient } from '@wix/sdk-types';
import { AssignRoleResponse, GetRolesResponse, QueryRolesOptions, QueryRolesResponse, UnassignRoleResponse } from './members-v1-role-authorization.universal.js';
export declare const __metadata: {
    PACKAGE_NAME: string;
};
export declare function assignRole(httpClient: HttpClient): AssignRoleSignature;
interface AssignRoleSignature {
    /** */
    (memberId: string, roleKey: string): Promise<AssignRoleResponse>;
}
export declare function unassignRole(httpClient: HttpClient): UnassignRoleSignature;
interface UnassignRoleSignature {
    /** */
    (memberId: string, roleKey: string): Promise<UnassignRoleResponse>;
}
export declare function getRoles(httpClient: HttpClient): GetRolesSignature;
interface GetRolesSignature {
    /** */
    (memberId: string): Promise<GetRolesResponse>;
}
export declare function queryRoles(httpClient: HttpClient): QueryRolesSignature;
interface QueryRolesSignature {
    /** */
    (options?: QueryRolesOptions | undefined): Promise<QueryRolesResponse>;
}
export { AssignRoleRequest, AssignRoleResponse, Empty, GetRolesRequest, GetRolesResponse, MemberRole, PolicyAssignedToContributor, PolicyRemovedFromContributor, PolicyUpdatedForContributor, Query, QueryRolesOptions, QueryRolesRequest, QueryRolesResponse, Role, UnassignRoleRequest, UnassignRoleResponse, } from './members-v1-role-authorization.universal.js';
